--[[
path: /TotemTimers/
filename: TotemTimers.lua
author: Donald Ephraim Curtis <dcurtis@cs.uiowa.edu>
created: Sat, 15 Jan 2005 14:15:00 -0800
updated: Mon, 24 Jan 2005 21:39:00 -0800

TotemTimers: Movable Totem Timers and Totem Expiration Notification
]]


-- *** make changes to config.lua *** ---
-- Internal Data
ActiveTotems = { };

-- Built-In Data ** Do Not Delete ** This information must be included to work properly.
TotemData = {};

TotemData[TT_DISEASE_CLEANSING] = {};
TotemData[TT_DISEASE_CLEANSING].icon = "Spell_Nature_DiseaseCleansingTotem";
TotemData[TT_DISEASE_CLEANSING].duration = 90;
TotemData[TT_DISEASE_CLEANSING].hits = 5;

TotemData[TT_EARTHBIND] = {};
TotemData[TT_EARTHBIND].icon = "Spell_Nature_StrengthOfEarthTotem02";
TotemData[TT_EARTHBIND].duration = 45; 
TotemData[TT_EARTHBIND].hits = 5;

TotemData[TT_FIRE_NOVA] = {};
TotemData[TT_FIRE_NOVA].icon = "Spell_Fire_SealOfFire"
TotemData[TT_FIRE_NOVA].duration = 5;
TotemData[TT_FIRE_NOVA].hits = 5;

TotemData[TT_FIRE_RESISTANCE] = {};
TotemData[TT_FIRE_RESISTANCE].icon = "Spell_Fire_FrostResistanceTotem"; 
TotemData[TT_FIRE_RESISTANCE].duration = 60;
TotemData[TT_FIRE_RESISTANCE].hits = 5;

TotemData[TT_FLAMETONGUE] = {};
TotemData[TT_FLAMETONGUE].icon = "Spell_Nature_GuardianWard";
TotemData[TT_FLAMETONGUE].duration = 90;
TotemData[TT_FLAMETONGUE].hits = 5;

TotemData[TT_FROST_RESISTANCE] = {};
TotemData[TT_FROST_RESISTANCE].icon = "Spell_Frost_FireResistanceTotem"; 
TotemData[TT_FROST_RESISTANCE].duration = 60;
TotemData[TT_FROST_RESISTANCE].hits = 5;

TotemData[TT_GRACE_OF_AIR] = {};
TotemData[TT_GRACE_OF_AIR].icon = "Spell_Nature_InvisibilityTotem";
TotemData[TT_GRACE_OF_AIR].hits = 5;
TotemData[TT_GRACE_OF_AIR][1] = { };
TotemData[TT_GRACE_OF_AIR][1].duration = 75;
TotemData[TT_GRACE_OF_AIR][2] = { };
TotemData[TT_GRACE_OF_AIR][2].duration = 90;

TotemData[TT_GROUNDING] = {};
TotemData[TT_GROUNDING].icon = "Spell_Nature_GroundingTotem";
TotemData[TT_GROUNDING].duration = 45;
TotemData[TT_GROUNDING].hits = 5;

TotemData[TT_HEALING_STREAM] = {} ;
TotemData[TT_HEALING_STREAM].icon = "INV_Spear_04";
TotemData[TT_HEALING_STREAM].duration = 60;
TotemData[TT_HEALING_STREAM].hits = 5;

TotemData[TT_MAGMA] = {};
TotemData[TT_MAGMA].icon = "Spell_Fire_SelfDestruct";
TotemData[TT_MAGMA].duration = 20;
TotemData[TT_MAGMA].hits = 5;

TotemData[TT_MANA_SPRING] = {};
TotemData[TT_MANA_SPRING].icon = "Spell_Nature_ManaRegenTotem";
TotemData[TT_MANA_SPRING].duration = 60;
TotemData[TT_MANA_SPRING].hits = 5;

TotemData[TT_MANA_TIDE] = {};
TotemData[TT_MANA_TIDE].icon = "Spell_Frost_SummonWaterElemental";
TotemData[TT_MANA_TIDE].duration = 12;
TotemData[TT_MANA_TIDE].hits = 5;

TotemData[TT_NATURE_RESISTANCE] = {};
TotemData[TT_NATURE_RESISTANCE].icon = "Spell_Nature_NatureResistanceTotem";
TotemData[TT_NATURE_RESISTANCE].duration = 60;
TotemData[TT_NATURE_RESISTANCE].hits = 5;

TotemData[TT_POISON_CLEANSING] = {};
TotemData[TT_POISON_CLEANSING].icon = "Spell_Nature_PoisonCleansingTotem";
TotemData[TT_POISON_CLEANSING].duration = 90;
TotemData[TT_POISON_CLEANSING].hits = 5;

TotemData[TT_SEARING] = {};
TotemData[TT_SEARING].icon = "Spell_Fire_SearingTotem";
TotemData[TT_SEARING].hits = 5;
TotemData[TT_SEARING][1] = { };
TotemData[TT_SEARING][1].duration = 30;
TotemData[TT_SEARING][2] = { };
TotemData[TT_SEARING][2].duration = 35;
TotemData[TT_SEARING][3] = { };
TotemData[TT_SEARING][3].duration = 40;
TotemData[TT_SEARING][4] = { };
TotemData[TT_SEARING][4].duration = 45;
TotemData[TT_SEARING][5] = { };
TotemData[TT_SEARING][5].duration = 50;
TotemData[TT_SEARING][6] = { };
TotemData[TT_SEARING][6].duration = 55;

TotemData[TT_SENTRY] = {};
TotemData[TT_SENTRY].icon = "Spell_Nature_RemoveCurse";
TotemData[TT_SENTRY].duration = 300;
TotemData[TT_SENTRY].hits = 5;

TotemData[TT_STONECLAW] = {};
TotemData[TT_STONECLAW].icon = "Spell_Nature_StoneClawTotem";
TotemData[TT_STONECLAW].duration = 15;
TotemData[TT_STONECLAW][1] = { };
TotemData[TT_STONECLAW][1].hits = 65;
TotemData[TT_STONECLAW][2] = { };
TotemData[TT_STONECLAW][2].hits = 165;
TotemData[TT_STONECLAW][3] = { };
TotemData[TT_STONECLAW][3].hits = 235;
TotemData[TT_STONECLAW][4] = { };
TotemData[TT_STONECLAW][4].hits = 295;
TotemData[TT_STONECLAW][5] = { };
TotemData[TT_STONECLAW][5].hits = 405;
TotemData[TT_STONECLAW][6] = { };
TotemData[TT_STONECLAW][6].hits = 486;

TotemData[TT_STONESKIN] = {};
TotemData[TT_STONESKIN].icon = "Spell_Nature_StoneSkinTotem";
TotemData[TT_STONESKIN].hits = 5;
TotemData[TT_STONESKIN][1] = { };
TotemData[TT_STONESKIN][1].duration = 45;
TotemData[TT_STONESKIN][2] = { };
TotemData[TT_STONESKIN][2].duration = 60;
TotemData[TT_STONESKIN][3] = { };
TotemData[TT_STONESKIN][3].duration = 60;
TotemData[TT_STONESKIN][4] = { };
TotemData[TT_STONESKIN][4].duration = 60;
TotemData[TT_STONESKIN][5] = { };
TotemData[TT_STONESKIN][5].duration = 60;
TotemData[TT_STONESKIN][6] = { };
TotemData[TT_STONESKIN][6].duration = 60;

TotemData[TT_STRENGTH_OF_EARTH] = {};
TotemData[TT_STRENGTH_OF_EARTH].icon = "Spell_Nature_EarthBindTotem";
TotemData[TT_STRENGTH_OF_EARTH].hits = 5;
TotemData[TT_STRENGTH_OF_EARTH][1] = { };
TotemData[TT_STRENGTH_OF_EARTH][1].duration = 45;
TotemData[TT_STRENGTH_OF_EARTH][2] = { };
TotemData[TT_STRENGTH_OF_EARTH][2].duration = 60;
TotemData[TT_STRENGTH_OF_EARTH][3] = { };
TotemData[TT_STRENGTH_OF_EARTH][3].duration = 75;
TotemData[TT_STRENGTH_OF_EARTH][4] = { };
TotemData[TT_STRENGTH_OF_EARTH][4].duration = 90;

TotemData[TT_TREMOR] = {};
TotemData[TT_TREMOR].icon = "Spell_Nature_TremorTotem";
TotemData[TT_TREMOR].duration = 90;
TotemData[TT_TREMOR].hits = 5;

TotemData[TT_WINDFURY] = {};
TotemData[TT_WINDFURY].icon = "Spell_Nature_Windfury";
TotemData[TT_WINDFURY].duration = 90;
TotemData[TT_WINDFURY].hits = 5;

TotemData[TT_WINDWALL] = {};
TotemData[TT_WINDWALL].icon = "Spell_Nature_EarthBind";
TotemData[TT_WINDWALL].duration = 60;
TotemData[TT_WINDWALL].hits = 5;

TT_EMPTY_ICON = "Spell_Totem_WardOfDraining";

--TTPlayerSpells = { };

-- functions
function TotemTimers( msg )
	command = string.lower(msg);

	local i = 1;
	arg = { };
	local tmparg = nil;
	for tmparg in string.gfind(command, "%w+") do
		arg[i] = tmparg;
		i = i + 1;
	end

	if( not arg[1] ) then
		for i = 1, 17 do
			DEFAULT_CHAT_FRAME:AddMessage(TT_SLASH[i]);
		end
		DEFAULT_CHAT_FRAME:AddMessage(TT_FORMAT_USAGE);
		DEFAULT_CHAT_FRAME:AddMessage(TT_WARN_USAGE);
		DEFAULT_CHAT_FRAME:AddMessage(TT_NOTIFY_USAGE);
		DEFAULT_CHAT_FRAME:AddMessage(TT_FIXED_USAGE);
		DEFAULT_CHAT_FRAME:AddMessage(TT_ORDER_USAGE);
	--elseif( arg[1] == "ms" or arg[1] == "multishaman" ) then
		--if( TTData.multishaman == 1 ) then
			--TTData.multishaman = 0;
			--DEFAULT_CHAT_FRAME:AddMessage(format(TT_MULTISHAMAN, "Off"));
		--else
			--DEFAULT_CHAT_FRAME:AddMessage(format(TT_MULTISHAMAN, "On"));
			--TTData.multishaman = 1;
		--end
		--TotemTimers_UpdateButtons();
	elseif( arg[1] == "left" or arg[1] == "bottom" ) then
		TTData.align = 1;
		DEFAULT_CHAT_FRAME:AddMessage(format(TT_ALIGN, command));
		TotemTimers_UpdateButtons();
	elseif( arg[1] == "right" or arg[1] == "top" ) then
		TTData.align = 0;
		DEFAULT_CHAT_FRAME:AddMessage(format(TT_ALIGN, command));
		TotemTimers_UpdateButtons();
	elseif( arg[1] == "hor" or command == "horizontal" ) then
		TTData.orientation = 0;
		TotemTimers_SetOrientation();
		DEFAULT_CHAT_FRAME:AddMessage(TT_HORIZONTAL);
	elseif( arg[1] == "vert" or command == "vertical" ) then
		TTData.orientation = 1;
		TotemTimers_SetOrientation();
		DEFAULT_CHAT_FRAME:AddMessage(TT_VERTICAL);
	elseif( arg[1] == "unlock" ) then
		TTData.lock = 0;
		DEFAULT_CHAT_FRAME:AddMessage(TT_UNLOCKED);
		TotemTimers_UpdateButtons();
	elseif( arg[1] == "lock" ) then
		TTData.lock = 1;
		DEFAULT_CHAT_FRAME:AddMessage(TT_LOCKED);
		TotemTimers_UpdateButtons();
	elseif( arg[1] == "show" ) then
		TTData.enable = 1;
		getglobal("TotemTimersFrame"):Show();
		DEFAULT_CHAT_FRAME:AddMessage(TT_ENABLED);
	elseif( arg[1] == "hide" ) then
		TTData.enable = 0;
		getglobal("TotemTimersFrame"):Hide();
		DEFAULT_CHAT_FRAME:AddMessage(TT_DISABLED);
	elseif( arg[1] == "format") then
		if( arg[2] ) then
			if( arg[2] == "blizzard" ) then
				TTData.format = 1;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_FORMAT, "Blizzard"));
			elseif( arg[2] == "melki" ) then
				TTData.format = 0;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_FORMAT, "Melki"));
			else
				TotemTimers_PrintUsage(TT_FORMAT_USAGE);
			end
		else
			TotemTimers_PrintUsage(TT_FORMAT_USAGE);
		end
	elseif( arg[1] == "warn" or arg[1] == "warnings") then
		if( arg[2] ) then
			if( arg[2] == "on" ) then
				TTData.warn = 1;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_WARN, "On"));
			elseif( arg[2] == "off" ) then
				TTData.warn = nil;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_WARN, "Off"));
			else
				TotemTimers_PrintUsage(TT_WARN_USAGE);
			end
		else
			TotemTimers_PrintUsage(TT_NOTIFY_USAGE);
		end
	elseif( arg[1] == "notify" or arg[1] == "notifications" ) then
		if( arg[2] ) then
			if( arg[2] == "on" ) then
				TTData.notify = 1;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_NOTIFY, "On"));
			elseif( arg[2] == "off" ) then
				TTData.notify = nil;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_NOTIFY, "Off"));
			else
				TotemTimers_PrintUsage(TT_NOTIFY_USAGE);
			end
		else
			TotemTimers_PrintUsage(TT_NOTIFY_USAGE);
		end			
		--[[
	elseif( arg[1] == "eventide" ) then
		local level = tonumber( arg[2] );
		if( level ) then
			if( level >= 0 and level <=5 ) then
				TTData.eventide = level;
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_EVENTIDE, level));
			else
				TotemTimers_PrintUsage(TT_EVENTIDE_USAGE);
			end
		else
			TotemTimers_PrintUsage(TT_EVENTIDE_USAGE);
		end
		]]
	elseif( arg[1] == "fixed" ) then
		if( arg[2] ) then
			if( arg[2] == "on" ) then
				TTData.fixed = 1;
				TotemTimers_UpdateButtons();
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_FIXED, "On"));
			elseif( arg[2] == "off" ) then
				TTData.fixed = 0;
				TotemTimers_UpdateButtons();
				DEFAULT_CHAT_FRAME:AddMessage(format(TT_FIXED, "Off"));
			else
				TotemTimers_PrintUsage(TT_FIXED_USAGE);
			end
		else
			TotemTimers_PrintUsage(TT_FIXED_USAGE);
		end			
	elseif( arg[1] == "order" ) then
		local j;
		if( arg[2] ) then
			for j = 2, 5 do
				if( arg[j] ) then
					arg[j] = string.upper(string.sub(arg[j],1,1)) .. string.lower(string.sub(arg[j],2));
					if( TotemTimers_ValidElement(arg[j]) ) then
						TTData.order[j-1] = arg[j];
					else 
						TotemTimers_PrintUsage(TT_ORDER_USAGE);
					end
				else
					TTData.order[j-1] = nil;
				end
			end
		else
			TotemTimers_PrintUsage(TT_ORDER_USAGE);
		end
		local ordermsg = "";
		for j, element in TTData.order do
			ordermsg = ordermsg.. element .. " ";
		end
		TotemTimers_UpdateButtons();
		DEFAULT_CHAT_FRAME:AddMessage(format(TT_ORDER, ordermsg));

	elseif( arg[1] == "reset" ) then
		DEFAULT_CHAT_FRAME:AddMessage(TT_RESET);
		TTData = { };
		TTData.enable = 1;
		TTData.flash = 10;
		--TTData.multishaman = 1;
		TTData.align = 0;
		TTData.lock = 0;
		TTData.dragging = 0;
		TTData.format = 0;
		--TTData.eventide = 0;
		TTData.notify = 1;
		TTData.warn = 1;
		TTData.orientation = 0;
		TTData.fixed = 0;
		TTData.order = { TT_EARTH, TT_FIRE, TT_WATER, TT_AIR };
		TTData.Default = { };
		TTData.Default.expireMsg = TT_DESTROYED
		TTData.Default.expireColor = { 1.0, 1.0, 0.0 };
		TTData.Default.warningMsg = TT_WARNING;
		TTData.Default.warningColor = { 0.0, 1.0, 0.0 };
		TTData.Default.warningTime = 10;
		TTData.Totems = { };
		TTData.Totems[TT_DISEASE_CLEANSING] = {};
		TTData.Totems[TT_EARTHBIND] = {};
		TTData.Totems[TT_FIRE_NOVA] = {};
		TTData.Totems[TT_FIRE_RESISTANCE] = {};
		TTData.Totems[TT_FLAMETONGUE] = {};
		TTData.Totems[TT_FROST_RESISTANCE] = {};
		TTData.Totems[TT_GRACE_OF_AIR] = {};
		TTData.Totems[TT_GROUNDING] = {};
		TTData.Totems[TT_HEALING_STREAM] = {} ;
		TTData.Totems[TT_MAGMA] = { warningTime=5 };
		TTData.Totems[TT_MANA_SPRING] = {};
		TTData.Totems[TT_MANA_TIDE] = { warningTime=-5 };
		TTData.Totems[TT_NATURE_RESISTANCE] = {};
		TTData.Totems[TT_POISON_CLEANSING] = {};
		TTData.Totems[TT_SEARING] = {};
		TTData.Totems[TT_SENTRY] = {};
		TTData.Totems[TT_STONECLAW] = {};
		TTData.Totems[TT_STONESKIN] = {};
		TTData.Totems[TT_STRENGTH_OF_EARTH] = {};
		TTData.Totems[TT_TREMOR] = {};
		TTData.Totems[TT_WINDFURY] = {};
		TTData.Totems[TT_WINDWALL] = {};
	end

end

function TotemTimers_PrintUsage(usage)
	if(usage) then
		DEFAULT_CHAT_FRAME:AddMessage(TT_USAGE.." "..usage);
	end

end

function TotemTimers_ValidElement(element)
	if(element) then
		if( element == TT_EARTH or
			element == TT_FIRE or
			element == TT_AIR or
			element == TT_WATER ) then
			return 1;
		end

	end
	return nil;

end
function TotemTimers_SetOrientation()
	if(TTData.orientation == 1) then
		TotemTimer2:ClearAllPoints();
		TotemTimer2:SetPoint("Top","TotemTimer1","Bottom",0,-15);
		TotemTimer3:ClearAllPoints();
		TotemTimer3:SetPoint("Top","TotemTimer2","Bottom",0,-15);
		TotemTimer4:ClearAllPoints();
		TotemTimer4:SetPoint("Top","TotemTimer3","Bottom",0,-15);
	else
		TotemTimer2:ClearAllPoints();
		TotemTimer2:SetPoint("Right","TotemTimer1","Left",-7,0);
		TotemTimer3:ClearAllPoints();
		TotemTimer3:SetPoint("Right","TotemTimer2","Left",-7,0);
		TotemTimer4:ClearAllPoints();
		TotemTimer4:SetPoint("Right","TotemTimer3","Left",-7,0);
	end
		
end

function TotemTimers_Disable() 
	TotemTimersFrame:UnregisterEvent("VARIABLES_LOADED");

	TotemTimersFrame:UnregisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
	TotemTimersFrame:UnregisterEvent("PLAYER_LEVEL_UP");
	TotemTimersFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");

	TotemTimersFrame:UnregisterEvent("SPELLCAST_STOP");

	TotemTimersFrame:UnregisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
	TotemTimersFrame:UnregisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
	TotemTimersFrame:UnregisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS");
	TotemTimersFrame:UnregisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE");
	TotemTimersFrame:UnregisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");

end

function TotemTimers_Enable() 
	TotemTimersFrame:RegisterEvent("VARIABLES_LOADED");

	TotemTimersFrame:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
	TotemTimersFrame:RegisterEvent("PLAYER_LEVEL_UP");
	TotemTimersFrame:RegisterEvent("PLAYER_ENTERING_WORLD");

	TotemTimersFrame:RegisterEvent("SPELLCAST_STOP");

	TotemTimersFrame:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
	TotemTimersFrame:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
	TotemTimersFrame:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS");
	TotemTimersFrame:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE");
	TotemTimersFrame:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
end
	
function TotemTimers_OnLoad()
	TotemTimers_Enable();

	--TotemTimers_SetupGlobals();
	TotemTimers_SetupHooks();

	this:RegisterForDrag("LeftButton");

end

function TotemTimers_DestroyTotem(totem)
	local element = ActiveTotems[totem].element;
	ActiveTotems[element] = nil;
	ActiveTotems[totem] = nil;
	TotemTimers_UpdateButtons();
end

function TotemTimers_ProcessAlias(text)
	if (TT_ALIAS) then
		for num, data in TT_ALIAS do
			text = string.gsub(text, data.alias, data.string);
		end
	end
	return text;
end

function TotemTimers_CastSpell(id, book)
	local start, duration, enable = GetSpellCooldown(id,book);
	-- DEFAULT_CHAT_FRAME:AddMessage("CastSpell Called");
	if( start <= 0 and duration <= 0 and TTState == 0 ) then
		TT = {};
		TT["spell"] = id;
		TT["book"] = book;
		TT["totem"], TT["rank"] = GetSpellName(id, book);
		TT["totem"] = string.gfind(TT["totem"], TT_TOTEM_REGEX)();
		if( TT["totem"] ) then
			TTState = 1;
			TT["rank"] = string.gfind(TT["rank"], TT_RANK_REGEX)();
			if( not TT["rank"] ) then
				TT["rank"] = 0;
			else
				TT["rank"] = tonumber(TT["rank"]);
			end
			TotemTimersTooltip:SetSpell(id,book);
			local ttdata = getglobal("TotemTimersTooltipTextLeft4"):GetText();
			TT["element"] = string.gfind(ttdata, TT_ELEMENT_REGEX)();

			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Spell = "..TT["spell"]);
			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Book = "..TT["book"]);
			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Totem = "..TT["totem"]);
			--if( TT["rank"] ) then
				--DEFAULT_CHAT_FRAME:AddMessage("[TT] Rank = "..TT["rank"]);
			--end
			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Element = "..TT["element"]);
		else
			TTState = 2;
		end
	end
end

function TotemTimers_UseAction(id, number, target)
	--DEFAULT_CHAT_FRAME:AddMessage("--------------------UseAction");
	local start, duration, enable = GetActionCooldown(id);
	local isUsable, notEnoughMana = IsUsableAction(id)
	if( start <= 0 and duration <= 0 and TTState == 0 and isUsable and not notEnoughMana ) then
		TT = {};
		TT["action"] = id;
		TT["number"] = number;
		TT["target"] = target;
		TotemTimersTooltip:SetAction(id);
		local ttdata = getglobal("TotemTimersTooltipTextLeft1"):GetText();
		if( ttdata ) then
			TT["totem"] = string.gfind(ttdata, TT_TOTEM_REGEX)();
		end
		if( TT["totem"] ) then
			TTState = 1;
			local ttdata = getglobal("TotemTimersTooltipTextRight1"):GetText();
			if( not ttdata ) then
				TT["rank"] = 0;
			else
				TT["rank"] = string.gfind(ttdata, TT_RANK_REGEX)();
				TT["rank"] = tonumber(TT["rank"]);
				getglobal("TotemTimersTooltipTextRight1"):SetText(nil);	
			end
			ttdata = getglobal("TotemTimersTooltipTextLeft4"):GetText();
			TT["element"] = string.gfind(ttdata, TT_ELEMENT_REGEX)();

			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Action = "..TT["action"]);
			--if( TT["number"] ) then
				--DEFAULT_CHAT_FRAME:AddMessage("[TT] Number = "..TT["number"]);
			--end
			--if( TT["target"] ) then
				--DEFAULT_CHAT_FRAME:AddMessage("[TT] Target = "..TT["target"]);
			--end
			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Totem = "..TT["totem"]);
			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Rank = "..TT["rank"]);
			--DEFAULT_CHAT_FRAME:AddMessage("[TT] Element = "..TT["element"]);
		else
			local inRange = IsActionInRange(id);
			if( inRange ) then
				TTState = 2;
				TT = {};
			end
		end
	end
end

function TotemTimers_CreateTotem()
	local at;
	if( TT ) then
		if( TotemData[TT["totem"]] ) then

			at = {};

			if( not TotemData[TT["totem"]][TT["rank"]] ) then
				--DEFAULT_CHAT_FRAME:AddMessage("Default");
				at.duration = TotemData[TT["totem"]].duration;
				at.hits = TotemData[TT["totem"]].hits;
			else
				if( TotemData[TT["totem"]][TT["rank"]].duration ) then
					at.duration = TotemData[TT["totem"]][TT["rank"]].duration;
				else
					at.duration = TotemData[TT["totem"]].duration;
				end
				if( TotemData[TT["totem"]][TT["rank"]].hits ) then
					at.hits = TotemData[TT["totem"]][TT["rank"]].hits;
				else
					at.hits = TotemData[TT["totem"]].hits;
				end
			end

			at.damage = 0;

			nameTalent, icon, iconx, icony, currRank, maxRank= GetTalentInfo(3,6);
			TT_Eventide = currRank;

			if( TT_Eventide and 
				( TT["totem"] == TT_HEALING_STREAM or 
				  TT["totem"] == TT_MANA_SPRING ) ) then
				at.duration = at.duration + ( TT_Eventide * 2);
			end

			-- DEFAULT_CHAT_FRAME:AddMessage("Duration: "..at.duration);
			at.spell = TT["spell"];
			at.book = TT["book"];
			at.action = TT["action"];
			at.number = TT["number"];
			at.target = TT["target"];
			at.totem = TT["totem"];
			at.rank = TT["rank"];
			at.element = TT["element"];
			at.flashTime = BUFF_FLASH_TIME_OFF;
			at.flashState = 0;


			--ActiveTotems[TT["element"]].duration = TotemData[TT["totem"]][TT["rank"]].duration;
			--ActiveTotems[TT["element"]].
			--ActiveTotems[TotemData[match[1]].element].duration = TotemData[match[1]].duration;
			--ActiveTotems[TotemData[match[1]].element].totem = match[1];
			--ActiveTotems[TotemData[match[1]].element].flashTime = BUFF_FLASH_TIME_OFF;
			--ActiveTotems[TotemData[match[1]].element].flashState = 0;

			--Create the expiration data, defaults and such.
			if( TTData.Totems[TT["totem"]] ) then
				if( TTData.Totems[TT["totem"]].warningTime ) then
					at.warningTime = TTData.Totems[TT["totem"]].warningTime;
				elseif( TTData.Default.warningTime ) then
					at.warningTime = TTData.Default.warningTime;
				end
			end

			ActiveTotems[TT["element"]] = at;
			ActiveTotems[TT["totem"]] = at;

			TT = nil;

			TotemTimers_UpdateButtons();
		end
	end
end


function TotemTimers_SetupHooks()
	TT_HookFunctions = {};
	TT_HookFunctions["UseAction"] = UseAction;
	UseAction = function(id,book) 
		TotemTimers_UseAction(id, book); 
		TT_HookFunctions["UseAction"](id,book); 
	end;
	TT_HookFunctions["CastSpell"] = CastSpell;
	CastSpell = function(id,book) 
		TotemTimers_CastSpell(id, book); 
		TT_HookFunctions["CastSpell"](id,book); 
	end;
end

function TotemTimers_OnEvent(event)
	--DEFAULT_CHAT_FRAME:AddMessage("Got Event:"..event);

	local match = { };
	if ( event == "VARIABLES_LOADED" ) then
		TotemTimers_SetupVariables();
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		TotemTimers_SetupGlobals();
		--TotemTimers_SetupHooks();
		TotemTimers_UpdateButtons();
	elseif ( event == "PLAYER_LEVEL_UP" ) then
		--TotemTimers_AdjustTotemDurations(arg1);
	elseif ( event == "SPELLCAST_STOP" ) then
		if( TTState == 1 ) then
			TotemTimers_CreateTotem();
		end
		TTState = 0;
		--DEFAULT_CHAT_FRAME:AddMessage("[TT] Finished Cast");
		--[[
	elseif ( event == "CHAT_MSG_SPELL_SELF_BUFF" ) then
		--TotemTimers_AdjustTotemDurations(UnitLevel("player"));
		match = { string.gfind(arg1, TT_CAST_REGEX)() };
		if ( table.getn( match ) >= 1 ) then
			TotemTimers_CreateTotem(match);
		end
		]]--
	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" or 
			 event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" or
			 event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE" or
			 event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS" ) then

		for num, regex in TT_DAMAGE_REGEX do
			match = { string.gfind(arg1, regex)() };
			if ( table.getn(match) >= 1 ) then
				match[1] = TotemTimers_ProcessAlias(match[1]);
				TotemTimers_TotemDamage(match[1], match[3]);
				break;
			end
		end
	end
		--TotemTimers_AdjustTotemDurations(UnitLevel("player"));
		--if ( event == "CHAT_MSG_COMBAT_FRIENDLY_DEATH" and TTData.multishaman == 0 ) then
			--match = { string.gfind(arg1, TT_DEATH_REGEX)() };
			--if ( table.getn( match ) >= 1 ) then
				--match[1] = TotemTimers_ProcessAlias(match[1]);
				--TotemTimers_TotemDeath(match);
			--end
end

function TotemTimers_UpdateButtons()

	local i,inc,j;
	if( TTData.align == 1 ) then
		i = 4;
		inc = -1;
	else
		i = 1;
		inc = 1;
	end
	for j = 1, 4 do
		getglobal("TotemTimer"..j.."Icon"):SetTexture("");
		getglobal("TotemTimer"..j.."Time"):SetText("");
		getglobal("TotemTimer"..j).element = nil;
	end
	for num, element in TTData.order do
		-- DEFAULT_CHAT_FRAME:AddMessage("Processing:"..element);
		if( ActiveTotems[element] ) then
			data = ActiveTotems[element];
			getglobal("TotemTimer"..i.."Icon"):SetTexture("Interface\\Icons\\"..TotemData[data.totem].icon);
			getglobal("TotemTimer"..i.."Time"):SetText(TotemTimer_FormatTime(data.duration));
			getglobal("TotemTimer"..i).element = element;
			getglobal("TotemTimer"..i.."Icon"):SetAlpha(1.0);
			TotemData[data.totem].button = getglobal("TotemTimer"..i);
			i = i + inc;
		elseif ( TTData.lock == 0 ) then
			getglobal("TotemTimer"..i.."Icon"):SetTexture("Interface\\Icons\\"..TT_EMPTY_ICON);
			getglobal("TotemTimer"..i.."Time"):SetText(element);
			getglobal("TotemTimer"..i.."Icon"):SetAlpha(1.0);
			getglobal("TotemTimer"..i.."Time"):SetTextColor(1.0,.8,0);
			i = i + inc;
		elseif ( TTData.fixed == 1) then
			i = i+inc;
		end
	end
end
    
--function TotemTimers_TotemDeath(totem)
	--if( match[2] == "" ) then
		--match[2] = "I";
	--end

	--if ( TTData.Totems[match[1]] ) then
		--TotemTimers_NotifyDestroy(format(TT_NAME_LEVEL_STRING, match[1],match[2]), TTData.Totems[match[1]]);
	--end
	--if ( TotemData[match[1]] ) then
		--TotemTimers_DestroyTotem( match[1] );
	--end
--end
--

function TotemTimers_TotemWarn(totem)
	if( TTData.Totems[totem] ) then
		local rank = ActiveTotems[totem].rank;
		if( rank == 0 ) then
			TotemTimers_NotifyWarning(format(TT_NAME_STRING, totem ), TTData.Totems[totem]);
		else
			TotemTimers_NotifyWarning(format(TT_NAME_LEVEL_STRING, totem, rank), TTData.Totems[totem]);
		end
	end
end

function TotemTimers_TotemDeath(totem)
	if( TTData.Totems[totem] ) then
		local rank = ActiveTotems[totem].rank;
		if( rank == 0 ) then
			TotemTimers_NotifyDestroy(format(TT_NAME_STRING, totem ), TTData.Totems[totem]);
		else
			TotemTimers_NotifyDestroy(format(TT_NAME_LEVEL_STRING, totem, rank), TTData.Totems[totem]);
		end
	end
	TotemTimers_DestroyTotem(totem);

end

function TotemTimers_TotemDamage(totem, damage)

	if ( ActiveTotems[totem] ) then
		ActiveTotems[totem].damage = ActiveTotems[totem].damage + damage;
		--DEFAULT_CHAT_FRAME:AddMessage("[TT] Damage: "..ActiveTotems[totem].damage);
		--DEFAULT_CHAT_FRAME:AddMessage("[TT] Hits: "..ActiveTotems[totem].hits);
		if ( ActiveTotems[totem].damage >= ActiveTotems[totem].hits ) then
			TotemTimers_TotemDeath(totem);
		end
	end


	--if ( TotemData[match[1]] ) then
		--TotemData[match[1]].damage = TotemData[match[1]].damage + match[3];
		--if ( TotemData[match[1]].damage >= TotemTimers_TotemHealth(match[1], match[2]) ) then
			--if ( TTData.Totems[match[1]] ) then
				--TotemTimers_NotifyDestroy(format(TT_NAME_LEVEL_STRING, match[1], match[2]), TTData.Totems[match[1]]);
			--end
			--TotemTimers_DestroyTotem(match[1]);
			--TotemData[match[1]].damage = 0;
		--end
	--end
end

function TotemTimers_NotifyWarning(name,item)
	if( TTData.warn ) then

		local warningMsg, warningColor;

		if ( item.warningMsg ) then
			warningMsg = item.warningMsg;
		else 
			if( TTData.Default.warningMsg ) then
				warningMsg = TTData.Default.warningMsg;
			else
				warningMsg = TT_WARNING;
			end
		end

		if ( item.warningColor ) then
			warningColor = item.warningColor;
		else
			if( TTData.Default.warningColor ) then
				warningColor = TTData.Default.warningColor;
			else
				warningColor =  { 1.0, 1.0, 1.0 } ;
			end
		end
		UIErrorsFrame:AddMessage(name.." "..warningMsg,  
			warningColor[1], 
			warningColor[2], 
			warningColor[3], 
			1.0, UIERRORS_HOLD_TIME);	

		if ( item.warningSound ) then
			PlaySoundFile(item.warningSound);
		elseif( TTData.Default.warningSound ) then
			PlaySoundFile(TTData.Default.warningSound);
		end
	end
		
end

function TotemTimers_NotifyDestroy(name,item)
	if( TTData.notify ) then
		local expireColor;

		if ( item.expireMsg ) then
			if ( item.expireColor ) then
				expireColor = item.expireColor;
			else
				if( TTData.Default.expireColor ) then
					expireColor = TTData.Default.expireColor;
				else
					expireColor =  { 1.0, 1.0, 1.0 } ;
				end
			end
			UIErrorsFrame:AddMessage(name.." "..item.expireMsg,  
				expireColor[1], 
				expireColor[2], 
				expireColor[3], 
				1.0, UIERRORS_HOLD_TIME);	
		elseif ( TTData.Default.expireMsg ) then
			if ( item.expireColor ) then
				expireColor = item.expireColor;
			else
				if( TTData.Default.expireColor ) then
					expireColor = TTData.Default.expireColor;
				else
					expireColor =  { 1.0, 1.0, 1.0 } ;
				end
			end
			UIErrorsFrame:AddMessage(name.." "..TTData.Default.expireMsg,  
				expireColor[1], 
				expireColor[2], 
				expireColor[3], 
				1.0, UIERRORS_HOLD_TIME);	
		end

		if ( item.expireSound ) then
			PlaySoundFile(item.expireSound);
		elseif ( TTData.Default.expireSound ) then
			PlaySoundFile(TTData.Default.expireSound);
		end
	end
		
end

function TotemTimers_TotemHealth(name,number)
	if ( name == TT_STONECLAW ) then
		return StoneclawHealth[number];
	end
	return 5;
end

function TotemTimers_SetupVariables()

	DEFAULT_CHAT_FRAME:AddMessage(TT_LOADED.." : Variables");
	UIErrorsFrame:AddMessage(TT_LOADED, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);

	if( not TTData ) then
		TTData = { };
		TTData.enable = 1;
		TTData.flash = 10;
		--TTData.eventide = 0;
		TTData.format = 0;
		TTData.fixed = 0;
		TTData.order = { TT_EARTH, TT_FIRE, TT_WATER, TT_AIR };
		TTData.notify = 1;
		TTData.warn = 1;
		TTData.align = 0;
		TTData.lock = 0;
		TTData.orientation = 0;
	end

	if( not TTData.Default ) then
		TTData.Default = { };
		TTData.Default.expireMsg = TT_DESTROYED
		TTData.Default.expireColor = { 1.0, 1.0, 0.0 };
		TTData.Default.warningMsg = TT_WARNING
		TTData.Default.warningColor = { 0.0, 1.0, 0.0 };
		TTData.Default.warningTime = 10;
	end
	
	if( not TTData.Totems ) then
		TTData.Totems = { };
		TTData.Totems[TT_DISEASE_CLEANSING] = {};
		TTData.Totems[TT_EARTHBIND] = {};
		TTData.Totems[TT_FIRE_NOVA] = {};
		TTData.Totems[TT_FIRE_RESISTANCE] = {};
		TTData.Totems[TT_FLAMETONGUE] = {};
		TTData.Totems[TT_FROST_RESISTANCE] = {};
		TTData.Totems[TT_GRACE_OF_AIR] = {};
		TTData.Totems[TT_GROUNDING] = {};
		TTData.Totems[TT_HEALING_STREAM] = {} ;
		TTData.Totems[TT_MAGMA] = { warningTime=5 };
		TTData.Totems[TT_MANA_SPRING] = {};
		TTData.Totems[TT_MANA_TIDE] = { warningTime=-5 };
		TTData.Totems[TT_NATURE_RESISTANCE] = {};
		TTData.Totems[TT_POISON_CLEANSING] = {};
		TTData.Totems[TT_SEARING] = {};
		TTData.Totems[TT_SENTRY] = {};
		TTData.Totems[TT_STONECLAW] = {};
		TTData.Totems[TT_STONESKIN] = {};
		TTData.Totems[TT_STRENGTH_OF_EARTH] = {};
		TTData.Totems[TT_TREMOR] = {};
		TTData.Totems[TT_WINDFURY] = {};
		TTData.Totems[TT_WINDWALL] = {};
	end

	for totem, data in TTData.Totems do
		TTData.Totems[totem].dmg = 0;
	end
	for totem, data in TotemData do
		data.damage = 0;
	end
	
	if ( TTData.enable == 0 ) then
		getglobal("TotemTimersFrame"):Hide();
	else
		getglobal("TotemTimersFrame"):Show();
	end

	TTState = 0;

	TotemTimers_SetOrientation();

end

--[[
function TotemTimers_Talents()
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
		nameTalent, icon, iconx, icony, currRank, maxRank= GetTalentInfo(t,i);
		DEFAULT_CHAT_FRAME:AddMessage("- "..nameTalent..": "..currRank.."/"..maxRank.." ["..t.."/"..i.."]");
	    end
	end
end
]]

function TotemTimers_SetupGlobals()
	DEFAULT_CHAT_FRAME:AddMessage(TT_LOADED.." : Globals");

	if( UnitClass("player") == TT_SHAMAN ) then
		-- Register our slash command
		SLASH_TOTEMTIMERS1 = "/totemtimers";
		SLASH_TOTEMTIMERS2 = "/tt";
		SlashCmdList["TOTEMTIMERS"] = function(msg)
			TotemTimers(msg);
		end
	else
		getglobal("TotemTimersFrame"):Hide();
		TotemTimers_Disable();
	end

	--TotemTimers_GetPlayerSpells();

	--TotemTimers_UpdateButtons();

end

--function TotemTimers_AdjustTotemDurations(level)
  --if(level >= 14) then
    --TotemData[TT_STONESKIN].duration = 60;
  --else return;
  --end
  --if(level >= 20) then
    --TotemData[TT_SEARING].duration = 35;
  --else return;
  --end
  --if(level >= 24) then
    --TotemData[TT_STRENGTH_OF_EARTH].duration = 60;
  --else return;
  --end
  --if(level >= 30) then
    --TotemData[TT_SEARING].duration = 40;
  --else return;
  --end
  --if(level >= 38) then
    --TotemData[TT_STRENGTH_OF_EARTH].duration = 75;
  --else return;
  --end
  --if(level >= 40) then
    --TotemData[TT_SEARING].duration = 45;                                                                                 
  --else return;
  --end
  --if(level >= 50) then
    --TotemData[TT_SEARING].duration = 50;
  --else return;
  --end
  --if(level >= 52) then
    --TotemData[TT_STRENGTH_OF_EARTH].duration = 90;
  --else return;
  --end
  --if(level >= 56) then
    --TotemData[TT_GRACE_OF_AIR].duration = 90;
  --else return;
  --end
  --if(level >= 60) then
    --TotemData[TT_SEARING].duration = 55;
  --else return;
  --end
--
  --if(TTData.eventide) then
	  --TotemData[TT_HEALING_STREAM].duration = 60 + (TTData.eventide * 2);
	  --TotemData[TT_MANA_SPRING].duration = 60 + (TTData.eventide * 2);
  --end
--end

-- Function ripped from CTMod, variable names changed
--function TotemTimers_GetPlayerSpells()
    --TTPlayerSpells = { };
    --for i = 1, GetNumSpellTabs(), 1 do
        --local name, texture, offset, numSpells = GetSpellTabInfo(i);
        --for y = 1, numSpells, 1 do
            --local spellName, rankName = GetSpellName(offset+y, BOOKTYPE_SPELL);
            --local useless, useless, rank = string.find(rankName, "(%d+)");
--
		--rankNum = tonumber(rank);
            --if ( not TTPlayerSpells[spellName] or TTPlayerSpells[spellName]["rank"] < rankNum ) then
                --TTPlayerSpells[spellName] = { ["rank"] = rankNum, ["tab"] = i+1, ["spell"] = y+offset };
            --end
        --end
    --end
--end 

